#!/bin/sh 
#
# Example init.d script with LSB support.
#
# Please read this init.d carefully and modify the sections to
# adjust it to the program you want to run.
#
# Copyright (c) 2007 Javier Fernandez-Sanguino <jfs@debian.org>
#
# This is free software; you may redistribute it and/or modify
# it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# This is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License with
# the Debian operating system, in /usr/share/common-licenses/GPL;  if
# not, write to the Free Software Foundation, Inc., 59 Temple Place,
# Suite 330, Boston, MA 02111-1307 USA
#
### BEGIN INIT INFO
# Provides:          zemberek-server
# Required-Start:    $network $local_fs
# Required-Stop:     
# Should-Start:      
# Should-Stop:       
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Turkish spellcheck server
# Description:       Zemberek is an open source, platform independent, general purpose Natural
#                    Language Processing library and toolset designed for Turkic languages,
#                    especially Turkish.
### END INIT INFO

set -e

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin

DAEMON=/usr/sbin/zemberek-server
NAME=zemberek-server
DESC="Zemberek spellcheck server"

PIDFILE=/var/run/$NAME.pid 
DIETIME=3

test -x $DAEMON || exit 0

. /lib/lsb/init-functions

# Default options, these can be overriden by the information
# at /etc/default/$NAME
DAEMON_OPTS=""          # Additional options given to the server 

DODTIME=10              # Time to wait for the server to die, in seconds
                        # If this value is set too low you might not
                        # let some servers to die gracefully and
                        # 'restart' will not work
                        
DAEMONUSER=zemberek

set -e

obtain_daemon_id() {
	local ident
	ident=$(getent passwd | grep "^$DAEMONUSER")
	[ "$ident" ] || return 1

	local ifs
	ifs="$IFS"
	IFS=':'
	set -- $ident
	IFS="$ifs"

	DAEMONUID="$3"
	DAEMONGID="$4"
}

running_pid() {
# Check if a given process pid's cmdline matches a given name
	pid=$1
	name=$2
	[ -z "$pid" ] && return 1
	[ ! -d /proc/$pid ] &&  return 1
	cmd=$(tr "\000" "\n" </proc/$pid/cmdline | head -n 1 | cut -d : -f 1)
	# Is this the expected server
	[ "$cmd" != "$name" ] &&  return 1
	return 0
}

running() {
# Check if the process is running looking at /proc
# (works for all users)

	# No pidfile, probably no daemon present
	[ ! -f "$PIDFILE" ] && return 1
	pid=$(cat $PIDFILE)
	running_pid $pid $NAME || return 1
	return 0
}

start_server() {
	start-stop-daemon --start --background --quiet --pidfile $PIDFILE \
		--chuid $DAEMONUSER --make-pidfile --exec $DAEMON -- $DAEMON_OPTS
	errcode=$?
	return $errcode
}

stop_server() {
	start-stop-daemon --stop --quiet --pidfile $PIDFILE \
		--user $DAEMONUSER --oknodo
	errcode=$?
	return $errcode
}

force_stop() {
# Force the process to die killing it manually
	[ ! -e "$PIDFILE" ] && return
	if running; then
		kill -15 $pid
		# Is it really dead?
		sleep "$DIETIME"
		if running; then
			kill -9 $pid
			sleep "$DIETIME"
			if running; then
				log_failure_msg "Cannot kill $NAME (pid=$pid)!"
				exit 1
			fi
		fi
	fi
	rm -f $PIDFILE
}

# Include defaults if available
if [ -f /etc/default/$NAME ] ; then
	. /etc/default/$NAME
fi

# Does the user exist?
if [ -n "$DAEMONUSER" ] ; then
	obtain_daemon_id || {
		log_failure_msg "The user $DAEMONUSER, required to run $NAME does not exist."
		exit 1
	}
fi

case "$1" in
  start)
	log_daemon_msg "Starting $DESC " "$NAME"
	if running ;  then
		log_progress_msg "apparently already running"
		log_end_msg 0
		exit 0
	fi
	if start_server && sleep "$DIETIME" && running ;  then
		log_end_msg 0
	else
		log_end_msg 1
	fi
	;;
  stop)
	log_daemon_msg "Stopping $DESC" "$NAME"
	if running ; then
		stop_server
		log_end_msg $?
	else
		log_progress_msg "apparently not running"
		log_end_msg 0
		exit 0
	fi
        ;;
  force-stop)
        # First try to stop gracefully the program
	$0 stop
	if running; then
		# If it's still running try to kill it more forcefully
		log_daemon_msg "Stopping (force) $DESC" "$NAME"
		force_stop
		log_end_msg $?
	fi
	;;
  restart|force-reload)
        log_daemon_msg "Restarting $DESC" "$NAME"
        stop_server
        # Wait some sensible amount, some server need this
        [ -n "$DIETIME" ] && sleep $DIETIME
        start_server
	sleep "$DIETIME"
        running
        log_end_msg $?
	;;
  status)
	log_daemon_msg "Checking status of $DESC" "$NAME"
	if running ;  then
		log_progress_msg "running"
		log_end_msg 0
	else
		log_progress_msg "apparently not running"
		log_end_msg 1
		exit 1
	fi
        ;;
  # Use this if the daemon cannot reload
  reload)
        log_warning_msg "Reloading $NAME daemon: not implemented, as the daemon"
        log_warning_msg "cannot re-read the config file (use restart)."
        ;;
  *)
	N=/etc/init.d/$NAME
	echo "Usage: $N {start|stop|force-stop|restart|force-reload|status}" >&2
	exit 1
	;;
esac

exit 0
